# generated by datamodel-codegen:
#   filename:  tmpwm19_qa1
#   timestamp: 2024-12-07T00:34:57+00:00

from __future__ import annotations

from typing import Any, Dict, List, Optional

from pydantic import BaseModel, Field


class Package(BaseModel):
    config: Optional[Any] = Field(
        None,
        description='Provides configuration options specific to the package engine.',
    )
    engine: str = Field(
        ...,
        description='Defines the format and deployment method for this package (e.g., helm, docker).',
    )
    name: str = Field(
        ...,
        description='The unique name of the package or release within this software group.',
    )


class Spec(BaseModel):
    packages: List[Package] = Field(
        ...,
        description='A list of individual software components included in this group. Each package specifies its name, type, and configuration details:',
    )


class SoftwareGroup(BaseModel):
    apiVersion: Optional[str] = Field(
        'core.platformspec.io/v1alpha1',
        description='APIVersion defines the versioned schema of this representation of an object.\nServers should convert recognized schemas to the latest internal value, and\nmay reject unrecognized values.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources',
    )
    kind: Optional[str] = Field(
        'SoftwareGroup',
        description='Kind is a string value representing the REST resource this object represents.\nServers may infer this from the endpoint the client submits requests to.\nCannot be updated.\nIn CamelCase.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds',
    )
    metadata: Optional[Dict[str, Any]] = None
    spec: Optional[Spec] = Field(
        None,
        description='SoftwareGroupSpec defines the desired state of SoftwareGroup.',
    )
    status: Optional[Dict[str, Any]] = Field(
        None,
        description='SoftwareGroupStatus defines the observed state of SoftwareGroup.',
    )
